using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Media;
using System.Threading;

namespace LockDownSvc
{
    /// <summary>
    /// Parental Control running as a window service to limit daily user time.
    /// 
    /// Author: Dennis Lang with some support routines by Pascal Ganaye
    /// LockDown service - Dec 2010
    /// http://home.comcast.net/~lang.dennis/
    /// </summary>
    public partial class LockDownSvc : ServiceBase
    {
        private LockDownBg m_lockDownBg = new LockDownBg();

        #region ==== Construction
        public LockDownSvc()
        {
            InitializeComponent();
            CanHandleSessionChangeEvent = true;
            CanShutdown = true;

            // InitializeAccountMonitor();
        }

       
        public void GuiStart()
        {
            LockDownFg lockDownFg = new LockDownFg();
        }
        #endregion

        #region ==== Standard Service Interface
        protected override void OnStart(string[] args)
        {
            m_lockDownBg.Start();
            base.OnStart(args);
        }

#if false
        protected override void OnContinue()
        {
            base.OnContinue();
        }
        protected override void OnPause()
        {
            base.OnPause();
        }
#endif

        protected override void OnSessionChange(SessionChangeDescription changeDescription)
        {
            base.OnSessionChange(changeDescription);
        }

        protected override void OnStop()
        {
            m_lockDownBg.Stop();
            base.OnStop();
        }

        protected override void OnShutdown()
        {
            m_lockDownBg.Stop();
            base.OnShutdown();
        }

        #endregion
    }
}
