﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace LockDownSvc 
{
    public partial class AlarmOptionsDlg : Form
    {
        public AlarmOptionsDlg(AlarmDlg.OptionInfo optionInfo)
        {
            InitializeComponent();

            imageFillClrBtn.Image = new Bitmap(18, 20);
            OptionInfo = optionInfo;
        }

        /*
        // ---- Image options ----
        public ImageLayout imageLayout = ImageLayout.Zoom;  // none, tile, center, stretch, zoom
        public Point imagePosition = Point.Empty;           // only used if layout is none
        public TimeSpan imageMotionTs = TimeSpan.Zero;
        public PointF imageMotionDir = PointF.Empty;        // seconds, minutes, hours, days
         
        public bool isFillMargin = true;
        public Point imageFillPixel = new Point(-1, -1);
        public Color imageFillColor = Color.Transparent;

        // ---- Text options ----
        public enum TextMode { eText, eTimeLeft, eTimeAt };
        public TextMode textMode = TextMode.eText;
        */

        public AlarmDlg.OptionInfo OptionInfo
        {
            set
            {
                // ---- Image options ----
                imgPosXnum.Value = value.imagePosition.X;
                imgPosYnum.Value = value.imagePosition.Y;

                motionXnum.Value = (decimal)value.imageMotionDir.X;
                motionYnum.Value = (decimal)value.imageMotionDir.Y;

                layoutCbx.SelectedIndex = (int)value.imageLayout;
               

                if (value.imageMotionTs.TotalDays > 1)
                {
                    unitCbox.SelectedIndex = 3;
                    speedNum.Value = (decimal)value.imageMotionTs.TotalDays;
                }
                else if (value.imageMotionTs.TotalHours > 1)
                {
                    unitCbox.SelectedIndex = 2;
                    speedNum.Value = (decimal)value.imageMotionTs.TotalHours;
                }
                else if (value.imageMotionTs.TotalMinutes > 1)
                {
                    unitCbox.SelectedIndex = 1;
                    speedNum.Value = (decimal)value.imageMotionTs.TotalMinutes;
                }
                else
                {
                    unitCbox.SelectedIndex = 0;
                    speedNum.Value = (decimal)value.imageMotionTs.TotalSeconds;
                }

                imageFillCk.Checked = value.isFillMargin;
                ImageFillColor = value.imageFillColor;

                // ---- Text options ----
                textRbtn.Checked = value.textMode == AlarmDlg.OptionInfo.TextMode.eText;
                textLeftRbtn.Checked = value.textMode == AlarmDlg.OptionInfo.TextMode.eTimeLeft;
                textAlarmAtRbtn.Checked = value.textMode == AlarmDlg.OptionInfo.TextMode.eTimeAt;
                txtPosXnum.Value = value.textPosition.X;
                txtPosYnum.Value = value.textPosition.Y;
            }

            get
            {
                AlarmDlg.OptionInfo optionInfo = new AlarmDlg.OptionInfo();

                // ---- Image options ----
                optionInfo.imageLayout = (ImageLayout)layoutCbx.SelectedIndex;

                optionInfo.imagePosition = new Point((int)imgPosXnum.Value, (int)imgPosYnum.Value);
                optionInfo.imageMotionDir = new PointF((float)motionXnum.Value, (float)motionYnum.Value);

                switch (unitCbox.SelectedIndex)
                {
                    case 0: // seconds
                        optionInfo.imageMotionTs = TimeSpan.FromSeconds((double)speedNum.Value);
                        break;
                    case 1: // minutes
                        optionInfo.imageMotionTs = TimeSpan.FromMinutes((double)speedNum.Value);
                        break;
                    case 2: // hours
                        optionInfo.imageMotionTs = TimeSpan.FromHours((double)speedNum.Value);
                        break;
                    case 3: // days
                        optionInfo.imageMotionTs = TimeSpan.FromDays((double)speedNum.Value);
                        break;

                }

                optionInfo.isFillMargin = imageFillCk.Checked;
                optionInfo.imageFillColor = ImageFillColor;

                // ---- Text options ----
                if (textRbtn.Checked)
                    optionInfo.textMode = AlarmDlg.OptionInfo.TextMode.eText;
                else if (textLeftRbtn.Checked)
                    optionInfo.textMode = AlarmDlg.OptionInfo.TextMode.eTimeLeft;
                else
                    optionInfo.textMode = AlarmDlg.OptionInfo.TextMode.eTimeAt;

                optionInfo.textPosition = new Point((int)txtPosXnum.Value, (int)txtPosYnum.Value);
                return optionInfo;
            }
        }

        private void imageFillClrBtn_Click(object sender, EventArgs e)
        {
            colorDLg.Color = ImageFillColor;
            if (colorDLg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                ImageFillColor = colorDLg.Color;
            }
        }


        private Color ImageFillColor
        {
            get
            {
                Bitmap img = new Bitmap(imageFillClrBtn.Image);
                return img.GetPixel(10, 10);
            }

            set
            {
                Graphics g = Graphics.FromImage(imageFillClrBtn.Image);
                g.Clear(value);
                g.Dispose();
                imageFillCk.Refresh();
            }
        }
      
    }
}
