﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace LockDownSvc
{
    /// <summary>
    /// Monitor mouse to detect when entering or leaving dialog.
    /// 
    /// Author: Dennis Lang
    /// LockDown service - Dec 2010
    /// http://home.comcast.net/~lang.dennis/
    /// </summary>
    public class MouseMoveFilter : IMessageFilter
    {
        private const int WM_MOUSELEAVE = 0x02A3;
        private const int WM_NCMOUSEMOVE = 0x0A0;
        private const int WM_MOUSEMOVE = 0x0200;
        private const int WM_NCMOUSELEAVE = 0x2A2;

        public object sender = null;
        public EventHandler MouseMove;
        public class MouseMoveEvent : EventArgs
        {
            public enum MouseAction { eNone, eEnter, eLeave };
            public MouseAction mouseAction;
        }

        public bool PreFilterMessage(ref Message m)
        {
            switch (m.Msg)
            {
                case WM_NCMOUSEMOVE:
                case WM_MOUSEMOVE:
                    if (MouseMove != null)
                        MouseMove(sender, new MouseMoveEvent() { mouseAction = MouseMoveEvent.MouseAction.eEnter });
                    break;

                case WM_NCMOUSELEAVE:
                case WM_MOUSELEAVE:
                    if (MouseMove != null)
                        MouseMove(sender, new MouseMoveEvent() { mouseAction = MouseMoveEvent.MouseAction.eLeave });
                    break;

            }
            return false;
        }
    }
}
